summaryrefslogtreecommitdiff
path: root/t/vala-per-target-flags.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-11-26 15:15:11 +0100
committerStefano Lattarini <stefano.lattarini@gmail.com>2012-11-26 15:15:11 +0100
commitb4896ce44ca5883bc34a2df0355ed3c8ad19485c (patch)
tree004bfd9be74848a300d7895953a440a03a259156 /t/vala-per-target-flags.sh
parent3e98c9d66b926a50ea7cabce7992bd30da2c6fb8 (diff)
downloadautomake-b4896ce44ca5883bc34a2df0355ed3c8ad19485c.tar.gz
tests: give few vala tests more significant names
* t/vala.sh: Rename ... * t/vala-grepping.sh: ... like this. * t/vala2.sh: Rename ... * t/vala-recursive-setup.sh: ... like this. * t/vala3.sh: Rename ... * t/vala-non-recursive-setup.sh: ... like this. * t/vala4.sh: Rename ... * t/vala-configure.sh: ... like this. * t/vala5.sh: Rename ... * t/vala-per-target-flags.sh: ... like this, and slightly improve heading comments. * t/list-of-tests.mk: Adjust. Signed-off-by: Stefano Lattarini <stefano.lattarini@gmail.com>
Diffstat (limited to 't/vala-per-target-flags.sh')
-rwxr-xr-xt/vala-per-target-flags.sh103
1 files changed, 103 insertions, 0 deletions
diff --git a/t/vala-per-target-flags.sh b/t/vala-per-target-flags.sh
new file mode 100755
index 000000000..5eae28185
--- /dev/null
+++ b/t/vala-per-target-flags.sh
@@ -0,0 +1,103 @@
+#! /bin/sh
+# Copyright (C) 1996-2012 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# Test per-target flags in vala support.
+
+required="pkg-config valac gcc GNUmake"
+. test-init.sh
+
+mkdir src
+
+cat >> configure.ac <<'END'
+AC_PROG_CC
+AM_PROG_CC_C_O
+AM_PROG_VALAC([0.7.0])
+PKG_CHECK_MODULES([GOBJECT], [gobject-2.0 >= 2.4])
+AC_CONFIG_FILES([src/Makefile])
+AC_OUTPUT
+END
+
+cat > Makefile.am <<'END'
+SUBDIRS = src
+END
+
+cat > src/Makefile.am <<'END'
+bin_PROGRAMS = foo bar
+foo_CFLAGS = $(GOBJECT_CFLAGS)
+foo_LDADD = $(GOBJECT_LIBS)
+foo_SOURCES = xfoo.vala
+bar_SOURCES = xbar.vala
+bar_VALAFLAGS = -D BAR
+bar_CFLAGS = $(GOBJECT_CFLAGS)
+bar_LDADD = $(GOBJECT_LIBS)
+END
+
+cat > src/xfoo.vala <<'END'
+int main ()
+{
+ stdout.printf ("foo\n");
+ return 0;
+}
+END
+
+cat > src/xbar.vala <<'END'
+void main ()
+{
+#if BAR
+ stdout.printf ("bar\n");
+#else
+ stdout.oops_an_invalid_method ();
+#endif
+}
+END
+
+$ACLOCAL
+$AUTOCONF
+$AUTOMAKE -a
+
+grep PKG_CHECK_MODULES configure && skip_ "pkg-config m4 macros not found"
+
+./configure
+$MAKE
+
+if ! cross_compiling; then
+ ./src/foo
+ ./src/bar
+ test "$(./src/foo)" = foo
+ test "$(./src/bar)" = bar
+fi
+
+# Test clean rules.
+
+cp config.status config.sav
+
+$MAKE clean
+test -f src/xfoo.c
+test -f src/xbar.c
+
+$MAKE distclean
+test -f src/xfoo.c
+test -f src/xbar.c
+
+# Re-create Makefile.
+mv config.sav config.status
+./config.status
+
+$MAKE maintainer-clean
+test ! -e src/xfoo.c
+test ! -e src/xbar.c
+
+: